commit 3b15983d32305b58581cf7eda4c92d24ac9772fc
Author: freddy77 <freddy77>
Date:   Wed Jul 21 05:56:27 2010 +0000

    avoid core if locale not detected

diff --git a/ChangeLog b/ChangeLog
index 7609a57..11fee4c 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Wed Jul 21 07:56:18 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/convert_tds2sql.c src/tds/mem.c:
+	- avoid core if locale not detected
+
 Tue Jul 20 09:56:36 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/error.c: fix compile using no-gnu compiler
 
@@ -2712,4 +2716,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3082 2010/07/20 07:56:51 freddy77 Exp $
+$Id: ChangeLog,v 1.3083 2010/07/21 05:56:27 freddy77 Exp $
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index 57e3af2..cb07a0e 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.71 2010/07/03 09:14:36 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.72 2010/07/21 05:56:27 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -70,6 +70,10 @@ odbc_convert_char(TDS_STMT * stmt, TDSCOLUMN * curcol, TDS_CHAR * src, TDS_UINT
 #ifdef ENABLE_ODBC_WIDE
 	} else {
 		conv = tds_iconv_get(tds, tds_dstr_cstr(&stmt->dbc->original_charset), conv->server_charset.name);
+		if (!conv)
+			conv = tds_iconv_get(tds, tds_dstr_cstr(&stmt->dbc->original_charset), "ISO-8859-1");
+		if (!conv)
+			conv = tds_iconv_get(tds, "ISO-8859-1", "ISO-8859-1");
 #endif
 	}
 
diff --git a/src/tds/mem.c b/src/tds/mem.c
index d5d8b01..f3167c3 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -1,6 +1,6 @@
 /* FreeTDS - Library of routines accessing Sybase and Microsoft databases
  * Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005  Brian Bruns
- * Copyright (C) 2005-2008 Frediano Ziglio
+ * Copyright (C) 2005-2010 Frediano Ziglio
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Library General Public
@@ -53,7 +53,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.201 2010/06/29 12:07:54 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.202 2010/07/21 05:56:27 freddy77 Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -850,6 +850,16 @@ tds_alloc_connection(TDSLOCALE * locale)
 
 	if (strtok_r(lc_all, ".", &tok)) {
 		char *encoding = strtok_r(NULL, "@", &tok);
+#ifdef _WIN32
+		/* windows give numeric codepage*/
+		if (encoding && atoi(encoding) > 0) {
+			char *p;
+			if (asprintf(&p, "CP%s", encoding) >= 0) {
+				free(encoding);
+				lc_all = encoding = p;
+			}
+		}
+#endif
 		if (encoding) {
 			if (!tds_dstr_copy(&connection->client_charset, encoding))
 				goto Cleanup;

